/******************************************************************************
**
** $Header: /homes/fish/danix/crater/src/lib/CC/geom/RCS/matrix4x4.h,v 1.3 1993/03/22 14:41:21 danix Exp danix $
**
** $Log: matrix4x4.h,v $
 * Revision 1.3  1993/03/22  14:41:21  danix
 * *** empty log message ***
 *
 * Revision 1.2  92/07/08  11:48:03  11:48:03  fxt (Filippo Tampieri)
 * *** empty log message ***
 * 
 * Revision 1.1  92/07/02  21:36:24  21:36:24  fxt (Filippo Tampieri)
 * Initial revision
 * 
**
******************************************************************************/

#ifndef MATRIX4X4_H
#define MATRIX4X4_H

#include <iostream.h>
#include <common.h>
#include <geom.h>
#include <vector4d.h>

class Matrix4x4 {
	friend Matrix4x4 Transpose(const Matrix4x4&);
	friend Matrix4x4 Inverse(const Matrix4x4&, Boolean&);
	friend Matrix4x4 operator+(const Matrix4x4&, const Matrix4x4&);
	friend Matrix4x4 operator-(const Matrix4x4&, const Matrix4x4&);
	friend Matrix4x4 operator*(const Matrix4x4&, const Matrix4x4&);
	friend Vector4d  operator*(const Matrix4x4&, const Vector4d&);
	friend ostream& operator<<(ostream&, const Matrix4x4&);
	friend istream& operator>>(istream&, Matrix4x4&);
private:
	Real m[4][4];
	Real Cofactor(int, int) const;
public:
	Matrix4x4()									{ ; }
	Matrix4x4(const Matrix4x4&);
	Real& operator()(int i, int j)				{ return m[i][j]; }
	const Real& operator()(int i, int j) const	{ return m[i][j]; }
	Matrix4x4& operator+=(const Matrix4x4&);
	Matrix4x4& operator-=(const Matrix4x4&);
	Matrix4x4& operator*=(const Matrix4x4&);
	Real Determinant() const;
	static Matrix4x4 I();
	static Matrix4x4 T(Real, Real, Real);
	static Matrix4x4 S(Real, Real, Real, Real sw = 1.0);
};

inline Matrix4x4 Inverse(const Matrix4x4& m)
{
	Boolean nonSingular;

	return Inverse(m, nonSingular);
}

#endif /* MATRIX4X4_H */

