/******************************************************************************
**
** $Header: /homes/fish/danix/crater/src/lib/CC/gext/RCS/ray.h,v 1.1 1993/09/15 10:41:52 danix Exp $
**
** $Log: ray.h,v $
 * Revision 1.1  1993/09/15  10:41:52  danix
 * Initial revision
 *
**
******************************************************************************/

#ifndef RAY_H
#define RAY_H

#include <geometry.h>

class Ray {
	friend ostream& operator<<(ostream&, const Ray&);
	friend istream& operator>>(istream&, Ray&);
protected:
	Point3d org;
	Vector3d dir;
public:
	const Point3d &origin;
	const Vector3d &direction;
	Real tmax;
	Real t;
	void *id;
	Ray();
	Ray(const Point3d&, const Point3d&, Boolean semiInfinite = FALSE);
	void set(const Point3d&, const Point3d&, Boolean semiInfinite = FALSE);
	Point3d operator()(Real t) const	{ return org + t * dir; }
};

inline Ray::Ray() : origin(org), direction(dir)
{
	tmax = 0.0;
	t = 0.0;
}

#endif

