/******************************************************************************
 *
 * $Source: /homes/fish/danix/latte/bsp/RCS/array.h,v $
 * $Author: danix $
 * $Locker:  $
 *
 * $Log: array.h,v $
 * Revision 1.1  1995/09/25  18:15:22  danix
 * Initial revision
 *
 *****************************************************************************/

#ifndef ARRAY_H
#define ARRAY_H

#include <stdlib.h>
#include <memory.h>
#include <common.h>

template <class T> class InfArray {
public:
	InfArray(int n = 0) : array(0), num(0) {
		len = (n > 0) ? n : 0;
		if (len > 0) {
			array = (T *)calloc(len, sizeof(T));
			if (array == NIL(T))
				Error("InfArray: calloc failed");
		}
	}
		
	~InfArray() { if (array != NIL(T)) free(array); }

	T& operator[](int i) {
		if (i < 0)
			Error("InfArray[]: negative index");
		if (i >= len) {
			// need to get more memory:
			len = max(2*len, i+1);
			T *tmp = (T *)calloc(len, sizeof(T));
			if (tmp == NIL(T))
				Error("InfArray[]: calloc failed");
			memcpy(tmp, array, num * sizeof(T));
			free(array);
			array = tmp;
		}
		num = max(i+1, num);
		return array[i];
	}

	T* getArray() const {
		if (num <= 0)
			return NIL(T);
		T *tmp = new T[num];
		if (tmp == NIL(T))
				Error("InfArray::getArray: new failed");
		memcpy(tmp, array, num * sizeof(T));
		return tmp;
	}

	unsigned int length() const { return num; }

private:
	T *array;
	unsigned int len, num;
};

#include <iostream.h>

template <class T>
inline ostream& operator<<(ostream& os, InfArray<T>& a)
{
	for (register int i = 0; i < a.length(); os << a[i++])
		os << " ";
	return os;
}

#endif

