/******************************************************************************
 *
 * $Source: /homes/fish/danix/latte/bsp/RCS/bsptree.h,v $
 * $Author: danix $
 * $Locker:  $
 *
 * $Log: bsptree.h,v $
 * Revision 1.2  1995/09/26  21:29:26  danix
 * Added a makeLeaf member function
 *
 * Revision 1.1  1995/09/25  18:18:12  danix
 * Initial revision
 *
 *****************************************************************************/

#ifndef BSPTREE_H
#define BSPTREE_H

#include <plane.h>
#include <object.h>
#include <list.h>

typedef List<ObjectPtr> ObjList;

class BSPtree {
private:
	Plane sep;
	BSPtree *pos;
	BSPtree *neg;
	ObjList *objects;
	int depth(int) const;
public:
	BSPtree()             : pos(0), neg(0), objects(0)  { }
	~BSPtree()  { delete pos; delete neg; delete objects; }
	Boolean IsLeaf() const       { return (!pos && !neg); }
	BSPtree& Pos() const                   { return *pos; }
	BSPtree& Neg() const                   { return *neg; }
	ObjList& Objects() const           { return *objects; }
	int Depth() const;
	void Init(ObjList&);
	void Insert(Object&);
	void makeLeaf(ObjList&);
	void print(int d = 0) const;
	void write(FILE *fp, Boolean root = FALSE) const;
};

inline int BSPtree::depth(int d) const
{
	if (IsLeaf())
		return d+1;
	int d1 = (pos) ? pos->depth(d) : 0;
	int d2 = (neg) ? neg->depth(d) : 0;
	return (d1 > d2) ? d1+1 : d2+1;
}

inline int BSPtree::Depth() const
{
	return depth(0);
}

#endif /* BSPTREE_H */
