/******************************************************************************
 *
 * $Source: /homes/sgi/danix/bsp/RCS/face.h,v $
 * $Author: danix $
 * $Locker:  $
 *
 * $Log: face.h,v $
 * Revision 1.1  1995/12/14  23:20:17  danix
 * Initial revision
 *
 *****************************************************************************/

#ifndef FACE_H
#define FACE_H

#include <stdio.h>
#include <color.h>

class Face {
public:
	Face() : n(0) { v[0] = v[1] = v[2] = v[3] = -1; }
	Face(int num, int a[], float col[]) {
		n = num;
		Assert(n <= 4);
		for (int i = 0; i < num; v[i] = a[i++]);
		color = RGB(col[0], col[1], col[2]);
	}
	Face(int a, int b, int c, float col[]) {
		n = 3;
		v[0] = a, v[1] = b, v[2] = c;
		color = RGB(col[0], col[1], col[2]);
	}
	Face(int a, int b, int c, const RGB& col) {
		n = 3;
		v[0] = a, v[1] = b, v[2] = c;
		color = col;
	}
	void set(int i, int j, int k) { n = 3; v[0] = i; v[1] = j; v[2] = k; }
	int  nv() const                                          { return n; }
	int& operator[](int i)                                { return v[i]; }
	int  operator[](int i) const                          { return v[i]; }
	RGB& rgb()                                           { return color; }
	float  r() const                                  { return color[0]; }
	float  g() const                                  { return color[1]; }
	float  b() const                                  { return color[2]; }
private:
	int n;
	int v[4];
	RGB color;
};


inline int printFace(FILE *fp, const Face& f)
{
	if (fprintf(fp, "%d  ", f.nv()) <= 0)
		return 0;

	for (int i = 0; i < f.nv(); i++) {
		if (fprintf(fp, "%d ", f[i]) <= 0)
			return 0;
	}

	return (fprintf(fp, "\n") > 0);
}

#endif
