/******************************************************************************
 *
 * $Source: /homes/fish/danix/latte/bsp/RCS/list.C,v $
 * $Author: danix $
 * $Locker:  $
 *
 * $Log: list.C,v $
 * Revision 1.1  1995/09/25  18:19:55  danix
 * Initial revision
 *
 *****************************************************************************/

#include <list.h>

template <class T>
void List<T>::insert(ListPos p, T i)
{
	ListItem<T> *node = new ListItem<T>(i, LPos(p)->next);
	if (node == 0)
		Error("List::insert: new failed");
	else {
		len++;
		LPos(p)->next = node;
		if (_last == LPos(p))
			_last = node;
	}
}

template <class T>
void List<T>::remove(ListPos p)
{
	ListItem<T> *t = LPos(p)->next;
	LPos(p)->next = LPos(p)->next->next;
	if (_last == t)
		_last = LPos(p);
	delete t;
	len--;
}

template <class T>
void List<T>::clear()
{
	while (!isEmpty()) {
		if (deleteData)
			delete (void *)pop();
		else
			remove(first());
	}
}

template <class T>
List<T>& List<T>::operator=(List<T>& src)
{
	clear();
	for (ListPos p = src.first(); !src.isEnd(p); p = src.next(p))
		append(retrieve(p));
	return *this;
}

template <class T>
void List<T>::apply(void (*f)(T))
{
	for (ListPos p = first(); !isEnd(p); p = next(p))
		f(retrieve(p));
}

template <class T> void swap(T array[], int first, int last)
{
	T tmp = array[first];
	array[first] = array[last];
	array[last] = tmp;
}

template <class T> void QuickSort(T array[], int first, int last)
{
	if (first >= last)
		return;
	if (first == last-1)
		if (array[first] <= array[last])
			return;
		else {
			swap(array, first, last);
			return;
		}

	// [first:last] is a span of length > 2
	
	// Choose an element for partitioning:
	int mid = (first + last)/2;
	swap(array, first, mid);
	T x = array[first];

	// partition:
	int i = first+1, j = last;
	while (i <= j) {
		if (array[i] <= x) {
			i++;
			continue;
		}
		if (array[j] > x) {
			j--;
			continue;
		}
		// array[i] > x && array[j] <= x
		swap(array, i++, j--);
	}
	swap(array, first, j);

	// recurse:
	QuickSort(array, first, j-1);
	QuickSort(array, j+1, last);
}

template <class T>
void List<T>::sort()
{
	register int i;
	ListPos p;
	T *array = ::new T[length()];

	if (!array)
		Error("List::sort: new failed");
	for (p = first(), i = 0; !isEnd(p); p = next(p), i++)
		array[i] = retrieve(p);
	QuickSort(array, 0, i-1);
	for (p = first(), i = 0; !isEnd(p); p = next(p), i++)
		store(p, array[i]);
	::delete[] array;
}


