//============================================================================
//
//		menu.h
//
//
//			Jonathan Shade
//
//============================================================================

#ifndef _MENU
#define _MENU

#include <Xm/Xm.h>
#include <Xm/MainW.h>
#include <Xm/PushB.h>
#include <Xm/ToggleB.h>

#include <ui.h>
#include "callbacks.h"


//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//
//
//		Menus
//
//
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

//
//	Generic blank menu item
//
uiMenuItem	blank_menu[] = {
    	    	NULL,
    	    	};

//----------------------------------------------------------------------------
//
//	Descriptor of the entire menu bar for the "Computeulator" window.
//	Descriptor of the entire menu bar for the "Geometry" window.
//	Descriptor of the entire menu bar for the "Image" window.
//
//
//----------------------------------------------------------------------------
uiMenuBarItem	compute_menu[]	= {	NULL };


//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//
//		Button Bars
//
//			Label, Pixmap, Class, Callback, Callback Data
//
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

   
//----------------------------------------------------------------------------
//
//		"Computeulator"	button bar
//
//
//----------------------------------------------------------------------------
uiHotkeyItem	compute_ht_bar[] = {
					{
					"Exit",
					 	NULL,
						&xmPushButtonWidgetClass,
						(XtCallbackProc) exit_cb,
						(XtPointer) 0 },
	
					NULL,
					};

//----------------------------------------------------------------------------
//
//		"Computeulator" callbacks
//
//
//----------------------------------------------------------------------------
uiCallbackList	compute_callbacks =
					{
					expose_callback,
					resize_callback,
					expose_callback,		/* no input		 */
					NULL, NULL, NULL		/* Callback data */
					};

#endif


