
#ifndef _STATE
#define _STATE

#include <Camera.h>
#include <ui.h>

#define STATE_NUM_WINDOWS	2

typedef struct
	{
	int	win_list[STATE_NUM_WINDOWS];
	int	animate;
	int	record;
	int	work_proc_id;
	int	current_frame;

	}	AnimateState;

typedef struct _graphics_state
	{
	int		antialias;
	int		multisample;
	int		texturing;
	int		geometry;
	int		tex_mem_size;
	int		output_header;
	
	Camera		*camera;
	} GraphicsState;

typedef struct _app_state
	{
	int				fly_mode;			// 0 = trackball    1 = superman	
	int				activeWindowList[STATE_NUM_WINDOWS];
	uiRenderWindow	*uiWindowList[STATE_NUM_WINDOWS];
	AnimateState	anim_state;
	GraphicsState	gr_state;
	} AppState;


#endif
