#include <GL/gl.h>
#include <GL/glu.h>
#include "axes.h"

#define	AXIS_LIST	1
#define AXES_LIST	2

GLfloat			mat_specular[4] =	{ 1.0, 1.0, 1.0, 1.0 };

GLUquadricObj	*Axis;
GLUquadricObj	*Origin;
GLUquadricObj	*AxisPoint;


stuffAxes::stuffAxes()
	{
	/*
	 * Set up axes
	 */
	glNewList( AXIS_LIST, GL_COMPILE );

		glColor3f( 0.6, 0.6, 0.6 );	
		Axis = gluNewQuadric();
		gluQuadricNormals( Axis, GLU_SMOOTH );
		gluQuadricDrawStyle( Axis, GLU_FILL );
		gluCylinder( Axis, 0.05, 0.05, 0.85, 20, 1 );

		// translate this
		glColor3f( 1.0, 0.0, 1.0 );	
		glTranslatef( 0.0, 0.0, 0.8 );

		AxisPoint = gluNewQuadric();
		gluQuadricNormals( AxisPoint, GLU_SMOOTH );
		gluQuadricDrawStyle( AxisPoint, GLU_FILL );
		gluCylinder( AxisPoint, 0.1, 0.0, 0.2, 20, 1 );
	
	glEndList();

	glNewList( AXES_LIST, GL_COMPILE );

		glMaterialfv( GL_FRONT, GL_SPECULAR, mat_specular );
		glMaterialf ( GL_FRONT, GL_SHININESS, 90.0 );
		glColorMaterial( GL_FRONT, GL_DIFFUSE );
		glEnable( GL_COLOR_MATERIAL );

		// make this a sphere
		glColor3f( 0.0, 0.0, 1.0 );	
		Origin = gluNewQuadric();
		gluQuadricNormals( Origin, GLU_SMOOTH );
		gluQuadricDrawStyle( Origin, GLU_FILL );
		gluSphere( Origin, 0.10, 10, 10 );

		// Y Axis
		glPushMatrix();
			glRotatef( -90.0, 1.0, 0.0, 0.0 );
			glCallList( AXIS_LIST );
		glPopMatrix();
	
		// X Axis
		glPushMatrix();
			glRotatef( 90.0, 0.0, 1.0, 0.0 );
			glCallList( AXIS_LIST );
		glPopMatrix();

		// Z Axis
			glCallList( AXIS_LIST );
		
		glDisable( GL_COLOR_MATERIAL );

	glEndList();

	}

stuffAxes::~stuffAxes()
	{
	}

int
stuffAxes::stuffAxesDraw()
	{
	if ( Axis )
		{
		glCallList( AXES_LIST );
		return 1;
		}
	else
		return 0;
	}

