//============================================================================
//
//		Geometry
//
//
//		This header file consolidates the header files
//		of all of the C++ objects that define things
//		like Vectors, Points, Planes, Matrices, etc.
//
//
//============================================================================

#ifndef _GEOMETRY_H
#define _GEOMETRY_H

#include "Vector3d.h"
#include "Vector3f.h"
#include "Point3d.h"
#include "Point3f.h"
#include "Vector4d.h"
#include "Vector4f.h"
#include "Point4d.h"
#include "Point4f.h"
#include "Matrix4d.h"
#include "Matrix4f.h"
#include "Plane.h"

#include <GL/gl.h>

class	Face {
	short int c;
	float *f;
};

class	Triangle {
public:
	int index[3];
};

class	Color {
public:
	GLfloat value[4];
};


class	Material {
public:
    float   ka;
    float   kd;
    float   ks;
    float   shiny;
    float   ambient[4];
    float   diffuse[4];
    float   specular[4];
};

#endif


