//============================================================================
//
//		Plane
//
//============================================================================

#ifndef _PLANE_H
#define _PLANE_H

#include <stdio.h>
#include "Point3d.h"

class Plane
	{

public:
				Plane();
				Plane( Point3d p, Point3d q, Point3d r );
				Plane( double A, double B, double C, double D );

	void		setValue( Point3d p, Point3d q, Point3d r );
	void		setValue( double A, double B, double C, double D );
	void		setValue( Point3d p, Normal3d n );

	Normal3d	getNormal3d();
	Point3d		getPoint3d();

	double		distanceTo  ( const Point3d &p );
	int			isInFront   ( const Point3d &p );
	int			isBehind    ( const Point3d &p );

	void		Print();
	void		Write( FILE* fp );

private:

	double		A,B,C,D;
	Normal3d	n;
	};


#endif


