//============================================================================
//
//		Trackball.h
//
//
//			Jonathan Shade
//
//============================================================================

#ifndef	_TRACKBALL_H
#define _TRACKBALL_H

#include "Geometry.h"
#include "Quat.h"

class	Trackball
	{
	public:

				Trackball();
				Trackball( Point3d center, double radius);
				~Trackball();	

		void		initBall( double quat[4] );
		void		initBall( Vector4d q );

		void		beginDrag( double x, double y );
		void		updateDrag( double x, double y );

		Matrix4d	getMatrix();

		Vector4d	getQuat();
		void		getQuat( double m[4] );

	private:
		void	MouseClickToVector( double mx, double my, double vec[3] );

		Quat	track_quat;
		Quat	begin_quat;

		Vector3d	ball_center;
		double		ball_radius;

		double	begin_vec[3];
		double	update_vec[3];
	};

#endif		

