//============================================================================
//
//		callbacks.h
//
//			Every function prototype here is for a callback related
//			to the (X windows) user interface.
//
//			Callbacks are of the form:
//
//				callback_name( widget, client_data, call_data );
//
//			Jonathan Shade
//
//============================================================================

#ifndef _CALLBACKS_H
#define _CALLBACKS_H

#include <Xm/Xm.h>

//
//		These are shared for all windows
// 
void	expose_callback( Widget, XtPointer, XtPointer );
void	resize_callback( Widget, XtPointer, XtPointer );

void	update_render( Widget, XtPointer, XtPointer );
void	one_step( Widget, XtPointer, XtPointer );

//
//		Preview window pull down menu
//
void	exit_cb  ( Widget, XtPointer, XtPointer );

void	choose_trackball( Widget, XtPointer, XtPointer );
void	choose_superman ( Widget, XtPointer, XtPointer );
void	choose_drive	( Widget, XtPointer, XtPointer );

void	reset_cb       ( Widget, XtPointer, XtPointer );
void	toggle_timings ( Widget, XtPointer, XtPointer );
void	toggle_fog     ( Widget, XtPointer, XtPointer );

//
//		Preview window button bar
//
void	update_window_config( Widget, XtPointer, XtPointer );

//
//		Geom window button bar
//
void	toggle_bb      ( Widget, XtPointer, XtPointer );

//
//		Image window button bar
//
void	toggle_frames( Widget, XtPointer, XtPointer );
void	toggle_leaf_textures( Widget, XtPointer, XtPointer );
void	toggle_image_geom( Widget, XtPointer, XtPointer );


#endif



