
/* Copyright (c) Mark J. Kilgard, 1994. */

/* This program is freely distributable without licensing fees
   and is provided without guarantee or warrantee expressed or
   implied. This program is -not- in the public domain. */

#include <GL/gl.h>
#include "glutstroke.h"

void
glutStrokeCharacter(void *font, int c)
	{
	int i, j;
	StrokeCharPtr	ch;
	StrokePtr		stroke;
	CoordPtr		coord;
	StrokeFontPtr	fontinfo = (StrokeFontPtr) font;

	if (c < 0 || c >= fontinfo->num_chars)
		return;

	ch = &(fontinfo->ch[c]);

	glLineWidth( 3.0 );

	if (ch)
		{
		stroke = ch->stroke;
		for (i = ch->num_strokes; i > 0; i-- )
			{
			glBegin(GL_LINE_STRIP);
			
			coord = stroke->coord;
			for (j = stroke->num_coords; j > 0; j-- )
				{
				glVertex2f(coord->x, coord->y);
				coord++;
				}

			glEnd();

			stroke++;
			}
		glTranslatef(ch->right, 0.0, 0.0);
		}

	glLineWidth( 1.0 );
	}
