//============================================================================
//
//		glx_resources.h
//
//			These are all of the strings that will be
//			sent off to glxChooseVisual in an attempt
//			to get a GL window.
//
//			Jonathan Shade
//
//============================================================================

#ifndef GLX_RESOURCES
#define GLX_RESOURCES


//-----------------------------------------------------------
//
//		Generic Visual Request Strings
//
//-----------------------------------------------------------

char	VR0_desc[] = "rgba: 8888  z:32  db";
char	VR1_desc[] = "rgba: 8888  z:24  db";
char	VR2_desc[] = "rgba: 4444  z:24  db";
char	VR3_desc[] = "rgba: 3328  z:24  db";
char	VR4_desc[] = "rgb:  444   z:24  db";
char	VR5_desc[] = "rgb:  121   z:24  db";

int VR0[] = {GLX_RGBA,
			GLX_RED_SIZE,   8,
			GLX_GREEN_SIZE, 8,
			GLX_BLUE_SIZE,  8,
			GLX_ALPHA_SIZE, 8,
			GLX_DEPTH_SIZE, 32,
			GLX_DOUBLEBUFFER,
			None};

int VR1[] = {GLX_RGBA,
			GLX_RED_SIZE,   8,
			GLX_GREEN_SIZE, 8,
			GLX_BLUE_SIZE,  8,
			GLX_ALPHA_SIZE, 8,
			GLX_DEPTH_SIZE, 24,
			GLX_DOUBLEBUFFER,
			None};

int VR2[] = {GLX_RGBA,
			GLX_RED_SIZE,   4,
			GLX_GREEN_SIZE, 4,
			GLX_BLUE_SIZE,  4,
			GLX_ALPHA_SIZE, 4,
			GLX_DEPTH_SIZE, 24,
			GLX_DOUBLEBUFFER,
			None};

int VR3[] = {GLX_RGBA,
			GLX_RED_SIZE,   3,
			GLX_GREEN_SIZE, 3,
			GLX_BLUE_SIZE,  2,
			GLX_ALPHA_SIZE,	8,
			GLX_DEPTH_SIZE, 24,
			GLX_DOUBLEBUFFER,
			None};

int VR4[] =	 {GLX_RGBA,
			GLX_RED_SIZE,   4,
			GLX_GREEN_SIZE, 4,
			GLX_BLUE_SIZE,  4,
			GLX_DEPTH_SIZE, 24,
			GLX_DOUBLEBUFFER,
			None};

int VR5[] = {GLX_RGBA,
			GLX_RED_SIZE,   1,
			GLX_GREEN_SIZE, 2,
			GLX_BLUE_SIZE,  1,
			GLX_DEPTH_SIZE, 24,
			GLX_DOUBLEBUFFER,
			None};

//-----------------------------------------------------------
//
//		IMPACT Visual Request Strings
//
//-----------------------------------------------------------
char	VR_IM0_desc[] = "rgba: 8888  z:24  db, accum";
char	VR_IM1_desc[] = "rgba: 8888  z:24  sb, accum";
char	VR_IM2_desc[] = "rgba: 8888  z:24  db";
char	VR_IM3_desc[] = "rgba: 8888  z:24  sb";

int VR_IM0[] = {GLX_RGBA,
				GLX_RED_SIZE,   8,
				GLX_GREEN_SIZE, 8,
				GLX_BLUE_SIZE,  8,
				GLX_ALPHA_SIZE,	8,
				GLX_DEPTH_SIZE, 24,
				GLX_DOUBLEBUFFER,
				GLX_ACCUM_RED_SIZE, 1,
				GLX_ACCUM_GREEN_SIZE, 1,
				GLX_ACCUM_BLUE_SIZE, 1,
				GLX_ACCUM_ALPHA_SIZE, 1,
				None};

int VR_IM1[] = {GLX_RGBA,
				GLX_RED_SIZE,   8,
				GLX_GREEN_SIZE, 8,
				GLX_BLUE_SIZE,  8,
				GLX_ALPHA_SIZE,	8,
				GLX_DEPTH_SIZE, 24,
				GLX_ACCUM_RED_SIZE, 1,
				GLX_ACCUM_GREEN_SIZE, 1,
				GLX_ACCUM_BLUE_SIZE, 1,
				GLX_ACCUM_ALPHA_SIZE, 1,
				None};

int VR_IM2[] = {GLX_RGBA,
				GLX_RED_SIZE,   8,
				GLX_GREEN_SIZE, 8,
				GLX_BLUE_SIZE,  8,
				GLX_ALPHA_SIZE,	8,
				GLX_DEPTH_SIZE, 24,
				GLX_DOUBLEBUFFER,
				None};

int VR_IM3[] = {GLX_RGBA,
				GLX_RED_SIZE,   8,
				GLX_GREEN_SIZE, 8,
				GLX_BLUE_SIZE,  8,
				GLX_ALPHA_SIZE,	8,
				GLX_DEPTH_SIZE, 24,
				None};

//-----------------------------------------------------------
//
//		Reality Engine Request Strings
//
//-----------------------------------------------------------

char	VR_RE0_desc[] = "rgba: 8888  z:32  db, accum";
char	VR_RE1_desc[] = "rgba: 8888  z:32  db, multisampled x4";
char	VR_RE2_desc[] = "rgba: 8888  z:32  db";

int VR_RE0[] = {GLX_RGBA,
				GLX_RED_SIZE,   8,
				GLX_GREEN_SIZE, 8,
				GLX_BLUE_SIZE,  8,
				GLX_ALPHA_SIZE, 8,
				GLX_DEPTH_SIZE, 32,
				GLX_DOUBLEBUFFER,
				GLX_ACCUM_RED_SIZE, 1,
				GLX_ACCUM_GREEN_SIZE, 1,
				GLX_ACCUM_BLUE_SIZE, 1,
				GLX_ACCUM_ALPHA_SIZE, 1,
				None};
			
int VR_RE1[] = {GLX_RGBA,
				GLX_RED_SIZE,   8,
				GLX_GREEN_SIZE, 8,
				GLX_BLUE_SIZE,  8,
				GLX_ALPHA_SIZE, 8,
				GLX_DEPTH_SIZE, 32,
				GLX_DOUBLEBUFFER,
//				GLX_SAMPLE_BUFFERS_SGIS, 1,
				GLX_SAMPLES_SGIS, 4,
				None};
			
int VR_RE2[] = {GLX_RGBA,
				GLX_RED_SIZE,   8,
				GLX_GREEN_SIZE, 8,
				GLX_BLUE_SIZE,  8,
				GLX_ALPHA_SIZE, 8,
				GLX_DEPTH_SIZE, 32,
				GLX_DOUBLEBUFFER,
				None};
							

#endif
