//============================================================================
//
//		menu.h
//
//
//			Jonathan Shade
//
//============================================================================

#ifndef _MENU
#define _MENU

#include <Xm/Xm.h>
#include <Xm/MainW.h>
#include <Xm/PushB.h>
#include <Xm/ToggleB.h>

#include "ui.h"
#include "callbacks.h"
#include "animate.h"


//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//
//
//		Menus
//
//
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

//
//	Generic blank menu item
//
uiMenuItem	blank_menu[] = {
    	    	NULL,
    	    	};

//----------------------------------------------------------------------------
//
//		Individual pulldown menus for the menu bar in the
//
//			"Preview" window.
//
//
//----------------------------------------------------------------------------
uiMenuItem	preview_admin_menu[] = {
    	    	{
				"Exit",
					&xmPushButtonWidgetClass, 'E', NULL, NULL,
					(XtCallbackProc) exit_cb,
					(XtPointer) 0,
					(uiMenuItem*) NULL },

    	    	NULL,
    	    	};

uiMenuItem	preview_camera_menu[] = {
				{
				"Trackball",
					&xmPushButtonWidgetClass, NULL, NULL, NULL,
					(XtCallbackProc) choose_trackball,
					(XtPointer)	0,
					(uiMenuItem*) NULL },

				{
				"Superman",
					&xmPushButtonWidgetClass, NULL, NULL, NULL,
					(XtCallbackProc) choose_superman,
					(XtPointer)	0,
					(uiMenuItem*) NULL },

				{
				"Drive",
					&xmPushButtonWidgetClass, NULL, NULL, NULL,
					(XtCallbackProc) choose_drive,
					(XtPointer)	0,
					(uiMenuItem*) NULL },
	   	    	{
				"Reset",
					&xmPushButtonWidgetClass, NULL, NULL, NULL,
					(XtCallbackProc) reset_cb,
					(XtPointer) 0,
					(uiMenuItem*) NULL },

    	    	NULL,
    	    	};

uiMenuItem	preview_animate_menu[] = {

				{
				"Preview",
					&xmToggleButtonWidgetClass, NULL, NULL, NULL,
					(XtCallbackProc) animate_choose_preview,
					(XtPointer)	0,
					(uiMenuItem*) NULL },

				{
				"Geometry",
					&xmToggleButtonWidgetClass, NULL, NULL, NULL,
					(XtCallbackProc) animate_choose_geometry,
					(XtPointer)	0,
					(uiMenuItem*) NULL },

				{
				"Image",
					&xmToggleButtonWidgetClass, NULL, NULL, NULL,
					(XtCallbackProc) animate_choose_image,
					(XtPointer)	0,
					(uiMenuItem*) NULL },

				{
				"Record",
					&xmToggleButtonWidgetClass, NULL, NULL, NULL,
					(XtCallbackProc) animate_choose_record,
					(XtPointer)	0,
					(uiMenuItem*) NULL },

				{
				"Print Camera",
					&xmPushButtonWidgetClass, NULL, NULL, NULL,
					(XtCallbackProc) animate_print_camera,
					(XtPointer)	0,
					(uiMenuItem*) NULL },

				{
				"Reset Camera",
					&xmPushButtonWidgetClass, NULL, NULL, NULL,
					(XtCallbackProc) animate_reset_cam,
					(XtPointer)	0,
					(uiMenuItem*) NULL },

				{
				"Start Animation",
					&xmPushButtonWidgetClass, NULL, NULL, NULL,
					(XtCallbackProc) animate_start,
					(XtPointer)	0,
					(uiMenuItem*) NULL },

				{
				"Stop Animation",
					&xmPushButtonWidgetClass, NULL, NULL, NULL,
					(XtCallbackProc) animate_stop,
					(XtPointer)	0,
					(uiMenuItem*) NULL },

				{
				"Read Curve File",
					&xmPushButtonWidgetClass, NULL, NULL, NULL,
					(XtCallbackProc) animate_read_curve,
					(XtPointer)	0,
					(uiMenuItem*) NULL },

    	    	NULL,
    	    	};

uiMenuItem	preview_other_menu[] = {
    	    	{
				"Fog",
					&xmToggleButtonWidgetClass, NULL, NULL, NULL,
					(XtCallbackProc) toggle_fog,
					(XtPointer)	0,
					(uiMenuItem*) NULL },

    	    	{
				"Print Timings",
					&xmToggleButtonWidgetClass, NULL, NULL, NULL,
					(XtCallbackProc) toggle_timings,
					(XtPointer)	0,
					(uiMenuItem*) NULL },

    	    	NULL,
    	    	};

//----------------------------------------------------------------------------
//
//	Descriptor of the entire menu bar for the "Preview" window.
//	Descriptor of the entire menu bar for the "Geometry" window.
//	Descriptor of the entire menu bar for the "Image" window.
//
//
//----------------------------------------------------------------------------
uiMenuBarItem	preview_menu[]	= {
									"Admin",	preview_admin_menu,
									"Camera",	preview_camera_menu,
									"Animate",	preview_animate_menu,
									"Other",	preview_other_menu,
									NULL,
								  };

uiMenuBarItem	geom_menu[]		= { NULL };

uiMenuBarItem	image_menu[]	= { NULL };

uiMenuBarItem	skycam_menu[]	= { NULL };

uiMenuBarItem	sidecam_menu[]		= { NULL };


//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//
//		Button Bars
//
//			Label, Pixmap, Class, Callback, Callback Data
//
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

   
//----------------------------------------------------------------------------
//
//		"Preview"	button bar
//
//
//----------------------------------------------------------------------------
uiHotkeyItem	preview_ht_bar[] = {
					{
					"Geometry Render",
					 	NULL,
						&xmToggleButtonWidgetClass,
						(XtCallbackProc) update_window_config,
						(XtPointer) 0 },
	
					{
					"Image Render",
					 	NULL,
						&xmToggleButtonWidgetClass,
						(XtCallbackProc) update_window_config,
						(XtPointer) 0 },
	
					{
					"Sky Cam",
					 	NULL,
						&xmToggleButtonWidgetClass,
						(XtCallbackProc) update_window_config,
						(XtPointer) 0 },
	
					{
					"Side Cam",
					 	NULL,
						&xmToggleButtonWidgetClass,
						(XtCallbackProc) update_window_config,
						(XtPointer) 0 },

					NULL,
					};

//----------------------------------------------------------------------------
//
//		"Geometry Render"	button bar
//
//
//----------------------------------------------------------------------------
uiHotkeyItem	geom_ht_bar[] = {
					{
					"Update Render",
						NULL,
						&xmPushButtonWidgetClass,
						(XtCallbackProc) update_render,
						(XtPointer) 0 },

					{
					"One Step",
						NULL,
						&xmPushButtonWidgetClass,
						(XtCallbackProc) one_step,
						(XtPointer) 0 },

					{
					"Bounding Boxes",
						NULL,
						&xmToggleButtonWidgetClass,
						(XtCallbackProc) toggle_bb,
						(XtPointer)	0 },

  					NULL,  
					};



//----------------------------------------------------------------------------
//
//		"Image Render"	button bar
//
//
//----------------------------------------------------------------------------
uiHotkeyItem	image_ht_bar[] = {
					{
					"Update Render",
						NULL,
						&xmPushButtonWidgetClass,
						(XtCallbackProc) update_render,
						(XtPointer) 0 },

					{
					"One Step",
						NULL,
						&xmPushButtonWidgetClass,
						(XtCallbackProc) one_step,
						(XtPointer) 0 },

					{
					"Show Frames",
						NULL,
						&xmToggleButtonWidgetClass,
						(XtCallbackProc) toggle_frames,
						(XtPointer) 0 },
					{
					"Draw Leaf Images",
						NULL,
						&xmToggleButtonWidgetClass,
						(XtCallbackProc) toggle_leaf_textures,
						(XtPointer) 0 },

					{
					"Draw Geometry",
						NULL,
						&xmToggleButtonWidgetClass,
						(XtCallbackProc) toggle_image_geom,
						(XtPointer) 0 },
  
					NULL,  
					};

uiHotkeyItem	skycam_ht_bar[] = {

					NULL,  
					};

uiHotkeyItem	sidecam_ht_bar[] = {

					NULL,  
					};


//----------------------------------------------------------------------------
//
//		"Preview" callbacks
//
//
//----------------------------------------------------------------------------
uiCallbackList	preview_callbacks = {
									expose_callback,
									resize_callback,
									input_callback,

									NULL, NULL, NULL		/* Callback data */
								 };
									
//----------------------------------------------------------------------------
//
//		"Image Render" callbacks
//
//
//----------------------------------------------------------------------------
uiCallbackList	image_callbacks = {
									expose_callback,
									resize_callback,
									input_callback,

									NULL, NULL, NULL		/* Callback data */
								 };
									
//----------------------------------------------------------------------------
//
//		"Geometry Render" callbacks
//
//
//----------------------------------------------------------------------------
uiCallbackList	geom_callbacks = {
									expose_callback,
									resize_callback,
									input_callback,

									NULL, NULL, NULL		/* Callback data */
								 };
									

//----------------------------------------------------------------------------
//
//		"Sky Cam" callbacks
//
//
//----------------------------------------------------------------------------
uiCallbackList	skycam_callbacks = {
									expose_callback,
									resize_callback,
									input_callback,

									NULL, NULL, NULL		/* Callback data */
								 };

//----------------------------------------------------------------------------
//
//		"Side Cam" callbacks
//
//
//----------------------------------------------------------------------------
uiCallbackList	sidecam_callbacks = {
									expose_callback,
									resize_callback,
									input_callback,

									NULL, NULL, NULL		/* Callback data */
								 };


#endif
