
#ifndef _PROJECTION_H
#define _PROJECTION_H

#include "Geometry.h"
#include "BoundBox.h"
#include "Camera.h"

void
proj_GetPower2Size( int ow, int oh, int & nw, int & nh );

int
proj_GetScreenPolygon(  const BoundBox & b,
					    double pixel_stretch, int wbox[2][2],
						double plane[4][3] );

int
proj_FeasibleViewport(  const BoundBox & b,
						double pixel_stretch, int vp_delta[2], int max[2] );

int
proj_FeasibleScreenPolygon( const BoundBox & b, const Camera & c,
							const Matrix4d & matrix,
							double pixel_stretch );

void
proj_GetActualScreenCorners( const BoundBox & b, const Matrix4d & matrix,
							 double sc[8][2] );

void
proj_GetApproxScreenCorners( double wc[8][3], const Matrix4d & matrix,
							 double sc[8][2] );

void
proj_GetActualWorldCorners(  const BoundBox & b,  const Matrix4d & matrix, 
							 double sc[8][2], double wc[8][3] );


int
proj_GetWorldCornersAndScreenPolygon( const BoundBox & bbox, double wc[8][3],
										int sp[4][2] );

#endif
