//============================================================================
//
//		readdb.h
//
//
//			Jonathan Shade
//
//============================================================================

#ifndef READDB_H
#define READDB_H

#include "Node.h"

//
//	"Private" functions
//
void	FinishLine( FILE *fp );
void	Read_BBox( FILE *dbfile, BoundBox & bbox );
int		Read_xform( FILE * dbfile, Matrix4d & m );
int		Read_Num_Children( char *fileName );

void	buildHierarchy( Node **root,    Matrix4d rootXform,
						char *fileName, int currentLevel );

int		readDescFile( char *dbfile, char list_file[256],
					  int *num_levels, char terr_file[256] );

void	Read_OFF( char *filename, VisualObject **obj );
void	Read_Terrain( char *filename, VisualObject **obj );

//
//	"Public" functions
//
void readDB(char *dbfile, Node **root, VisualObject **background );


#endif
