
#ifndef _STATE
#define _STATE

#include <stdio.h>

#include "Bspline.h"
#include "Camera.h"
#include "Metric.h"
#include "TriangleList.h"
#include "ui.h"
#include "stats.h"

#define STATE_NUM_WINDOWS	5
#define	GH_REALITY_ENGINE	1
#define GH_MAXIMUM_IMPACT	2
#define GH_HIGH_IMPACT		3

#define BR_IMAGE    0
#define BR_GEOM     1
#define BR_SIDECAM  2

typedef struct
	{
	int	win_list[STATE_NUM_WINDOWS];
	int	animate;
	int	record;
	int	work_proc_id;
	int	current_frame;
	int	starting_frame;
	int ending_frame;
	int	num_frames;
	int frame_step;
	int	terminate_on_finish;
	int batch_renderer;
	int animating;
	int lookat;			// 0 = tangent   1 = binormal
	float param;
	float speed;
	char curve_file[256];
	char movie_dir[256];
	}	AnimateState;

typedef struct _graphics_state
	{
	int			grhardware;		// 1 = RE2, 2 = Max IMPACT, 3 = High IMPACT
	int			aa;				// antialiasing ?
	int			db;				// double buffering ?
	int			numSamples;
	int			drawHz;
	int			drawFog;
	int			drawFrames;
	int			drawPsuedoColor;
	int			drawBoundingBoxes;
	int			drawLeafTextures;
	int			drawGeom;
	int			drawEnvironment;
	int			num_env_objs;

	int			inflate;
	int			printTimings;
	double		pixel_eps;
	double		inflation;
	MetricType	metric_type;

	float		zoomSpeed;
	float		dragSpeed;
	double		ic_x,ic_y,ic_z;
	
	Camera		 *camera;
	Bspline		 *bspline;
	TriangleList *env_objs;
	char		 **env_obj_names;
	} GraphicsState;

typedef struct _app_state
	{
	// 0 = trackball    1 = superman	
	char			db_filename[256];
	int				fly_mode;
	int				activeWindowList[STATE_NUM_WINDOWS];
	uiRenderWindow	*uiWindowList[STATE_NUM_WINDOWS];
	AnimateState	anim_state;
	GraphicsState	gr_state;
	Stat			stats;
	} AppState;


#endif



