#include <stdlib.h>
#include <stdio.h>

#include <stats.h>

void
init_FrameStat( FrameStat & stat )
	{
	stat.time          = 0;
	stat.time_cull     = 0;
	stat.time_update   = 0;
	stat.time_draw     = 0;

	stat.num_tri_geom  = 0;

	stat.sum_tmap_size         = 0;
	stat.sum_tmap_size_used    = 0;
	stat.sum_tmap_size_drawn   = 0;
	stat.sum_tmap_size_created = 0;
	stat.sum_tmap_size_deleted = 0;

	stat.num_tmap         = 0;
	stat.num_tmap_drawn   = 0;
	stat.num_tmap_created = 0;
	stat.num_tmap_deleted = 0;

	stat.num_composites      =  0;
	stat.max_composite_depth = -1;
	stat.sum_composite_depth =  0;

	stat.max_frames_valid = -1;
	stat.min_frames_valid = -1;
	stat.sum_frames_valid =  0;
	}

void
read_FrameStat( FILE *fp, FrameStat & stat )
	{
	fscanf( fp, "%d", &stat.time );
	fscanf( fp, "%d", &stat.time_cull );
	fscanf( fp, "%d", &stat.time_update );
	fscanf( fp, "%d", &stat.time_draw );
	fscanf( fp, "%d", &stat.num_tri_geom );
	fscanf( fp, "%d", &stat.sum_tmap_size );
	fscanf( fp, "%d", &stat.sum_tmap_size_used );
	fscanf( fp, "%d", &stat.sum_tmap_size_drawn );
	fscanf( fp, "%d", &stat.sum_tmap_size_created );
	fscanf( fp, "%d", &stat.sum_tmap_size_deleted );
	fscanf( fp, "%d", &stat.num_tmap );
	fscanf( fp, "%d", &stat.num_tmap_drawn );
	fscanf( fp, "%d", &stat.num_tmap_created );
	fscanf( fp, "%d", &stat.num_tmap_deleted );
	fscanf( fp, "%d", &stat.num_composites );
	fscanf( fp, "%d", &stat.max_composite_depth );
	fscanf( fp, "%d", &stat.sum_composite_depth );
	fscanf( fp, "%d", &stat.max_frames_valid );
	fscanf( fp, "%d", &stat.min_frames_valid );
	fscanf( fp, "%d", &stat.sum_frames_valid );
	}

void
print_FrameStat( FILE *fp, FrameStat & stat )
	{
	fprintf( fp, "%d\n", stat.time );
	fprintf( fp, "%d\n", stat.time_cull );
	fprintf( fp, "%d\n", stat.time_update );
	fprintf( fp, "%d\n", stat.time_draw );
	fprintf( fp, "%d\n", stat.num_tri_geom );
	fprintf( fp, "%d\n", stat.sum_tmap_size );
	fprintf( fp, "%d\n", stat.sum_tmap_size_used );
	fprintf( fp, "%d\n", stat.sum_tmap_size_drawn );
	fprintf( fp, "%d\n", stat.sum_tmap_size_created );
	fprintf( fp, "%d\n", stat.sum_tmap_size_deleted );
	fprintf( fp, "%d\n", stat.num_tmap );
	fprintf( fp, "%d\n", stat.num_tmap_drawn );
	fprintf( fp, "%d\n", stat.num_tmap_created );
	fprintf( fp, "%d\n", stat.num_tmap_deleted );
	fprintf( fp, "%d\n", stat.num_composites );
	fprintf( fp, "%d\n", stat.max_composite_depth );
	fprintf( fp, "%d\n", stat.sum_composite_depth );
	fprintf( fp, "%d\n", stat.max_frames_valid );
	fprintf( fp, "%d\n", stat.min_frames_valid );
	fprintf( fp, "%d\n", stat.sum_frames_valid );
	}

int
read_stats_file( char *filename, Stat & stats )
	{
	stats.fp = fopen( filename, "r" );

	if( stats.fp == NULL )
		{
		fprintf(stderr,"Cant open %s\n", filename );
		return(0);
		}

	fscanf(stats.fp,"%d", &stats.num_frames);
	fscanf(stats.fp,"%d", &stats.read_time);
	fscanf(stats.fp,"%d", &stats.neighbor_time);
	fscanf(stats.fp,"%d", &stats.size);
	fscanf(stats.fp,"%d", &stats.size_extra);

	stats.frame = new FrameStat[stats.num_frames];

	for( int i=0; i<stats.num_frames ; i++ )
		{
		read_FrameStat( stats.fp, stats.frame[i] );
		}

	fclose( stats.fp );

	return 1;
	}


void
print_stat_file( Stat & stats )
	{
	fprintf(stats.fp, "%d\n",stats.num_frames );
	fprintf(stats.fp, "\n");
	fprintf(stats.fp, "%d\n",stats.read_time );
	fprintf(stats.fp, "%d\n",stats.neighbor_time );
	fprintf(stats.fp, "%d\n",stats.size );
	fprintf(stats.fp, "%d\n",stats.size_extra );

	for( int i=0 ; i<stats.num_frames ; i++ )
		{
		fprintf( stats.fp, "\n" );
		print_FrameStat( stats.fp, stats.frame[i] );
		fprintf( stats.fp, "\n" );
		}
	}
