
#ifndef _STATS_H
#define _STATS_H

typedef struct
	{

	int		time;
	int		time_cull;
	int		time_update;
	int		time_draw;
	int		num_tri_geom;

	int		sum_tmap_size;
	int		sum_tmap_size_used;
	int		sum_tmap_size_drawn;
	int		sum_tmap_size_created;	
	int		sum_tmap_size_deleted;

	int		num_tmap;
	int		num_tmap_drawn;
	int		num_tmap_created;
	int		num_tmap_deleted;

	int		num_composites;
	int		max_composite_depth;
	int		sum_composite_depth;

	int		max_frames_valid;
	int		min_frames_valid;
	int		sum_frames_valid;
	} FrameStat;

typedef struct _stat
	{
	int  num_frames;
	int  read_time;
	int  neighbor_time;
	int  size;
	int  size_extra;
	FILE *fp;
	FrameStat *frame;
	} Stat;

int		read_stats_file( char *filename, Stat & );
void	print_stat_file( Stat & );

void	init_FrameStat ( FrameStat & );
void	read_FrameStat ( FILE *, FrameStat & );
void	print_FrameStat( FILE *, FrameStat & );

#endif

